
--My Scripts

local player_script = require "Scripts/player"
local ui = require "Scripts/ui"
local maps = require "Scripts/map"
local audio = require "Scripts/audio"
local general = require "Scripts/general"

--Modules

local bump = require "Modules/bump"
world = bump.newWorld()

function love.load()
	love.graphics.setFont(sansFont)
	ui:start()
	maps:titleScene()
end

function love.update(dt)
	player_script:update()
	ui:update()
end

function love.draw()
	for _, o in pairs(objects) do
		if o.color ~= nil then
			love.graphics.setColor(o.color.r, o.color.g, o.color.b, o.color.a)
		else
			love.graphics.setColor(1, 1, 1, 1)
		end
		if o.draw_mode == "Rectangle" then
			love.graphics.rectangle("fill", o.x, o.y, o.w, o.h)
		end

		if o.draw_mode == "Image" then
			love.graphics.draw(o.image, o.x, o.y, o.rot, o.w, o.h, 0, 0)
		end

		if o.draw_mode == "Text" then
			if o.selected ~= nil then
				if o.selected == true then
					love.graphics.setColor(1, 1, 0, 1)
				end
			end
			love.graphics.print(o.text, o.x, o.y, o.rot, o.width, o.h, 0, 0)
		end

	end
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.print("FPS: " .. love.timer.getFPS() ,window_width - 100, 5, 0, 0.25, 0.25, 0, 0)
	if player ~= nil then
		love.graphics.print("Pos: " .. player.x ..  ", " ..  player.y, 5, 5, 0, 0.25, 0.25, 0, 0)
	end
end

function love.keypressed(key, scancode, isRepeat)

	if key == "escape" and current_map ~= "Title" then
		love.event.quit()
	end

	if (ui.running == true) then
		if key == "up" then
			uiPosition.y = uiPosition.y - 1
		end

		if key == "down" then
			uiPosition.y = uiPosition.y + 1
		end


		if key == "z" then
			if oldSelected ~= {} then
				oldSelected.run()
			end
		end
	end
end